;NSIS Modern User Interface version 1.63
;Basic Example Script
;Written by Joost Verburg

!define MUI_PRODUCT "Loglet Lab 2" ;Define your own software name here
!define MUI_VERSION "0.5" ;Define your own software version here

!include "MUI.nsh"

;--------------------------------
;Configuration
  !define LLDIR "."
  Icon "${LLDIR}\ll_icon.ico"

  ;General
  OutFile "LL-install.exe"

  ;Folder selection page
  InstallDir "$PROGRAMFILES\${MUI_PRODUCT}"
  
  ;Remember install folder
  InstallDirRegKey HKCU "Software\${MUI_PRODUCT}" ""

;--------------------------------
;Modern UI Configuration
  !define MUI_WELCOMEPAGE
  !define MUI_LICENSEPAGE
;  !define MUI_COMPONENTSPAGE
  !define MUI_DIRECTORYPAGE
  
  !define MUI_ABORTWARNING
  
  !define MUI_UNINSTALLER
  !define MUI_UNCONFIRMPAGE

  !define MUI_FINISHPAGE_SHOWREADME ${INSTDIR}\readme.txt
;--------------------------------
;Languages
 
  !insertmacro MUI_LANGUAGE "English"
  
;--------------------------------
;Language Strings

  ;Description
  LangString DESC_SecCopyUI ${LANG_ENGLISH} "Copy the modern.exe file to the application folder."

;--------------------------------
;Data
  
  LicenseData "${LLDIR}\License.txt"

;--------------------------------
;Installer Sections

Section "JARs" SecCopyUI

  ;ADD YOUR OWN STUFF HERE!

  SetOutPath "$INSTDIR"
  ;File "${NSISDIR}\Contrib\UIs\modern.exe"
  File "${LLDIR}\LogletLabClasses.jar"
  File "${LLDIR}\jdom.jar"
  File "${LLDIR}\jxl.jar"
  File "${LLDIR}\readme.txt"
  File "${LLDIR}\License.txt"
  File "${LLDIR}\ll_icon.ico"
  File "${LLDIR}\ll_icon16.png"
  File "${LLDIR}\llsplash.png"

  ;Store install folder
  ;WriteRegStr HKCU "Software\${MUI_PRODUCT}" "" $INSTDIR
  
  CreateShortCut "$INSTDIR\Loglet Lab 2.lnk" "javaw" "-cp LogletLabClasses.jar;jxl.jar;jdom.jar LogletLab.LogletLabMain" "$INSTDIR\ll_icon.ico"

  CreateShortCut "$DESKTOP\Loglet Lab 2.lnk" "javaw" "-cp LogletLabClasses.jar;jxl.jar;jdom.jar LogletLab.LogletLabMain" "$INSTDIR\ll_icon.ico"

  ;Create uninstaller
  WriteUninstaller "$INSTDIR\Uninstall.exe"

  CreateDirectory "$SMPROGRAMS\${MUI_PRODUCT}"

  CreateShortCut "$SMPROGRAMS\${MUI_PRODUCT}\Loglet Lab 2.lnk" "javaw" "-cp LogletLabClasses.jar;jxl.jar;jdom.jar LogletLab.LogletLabMain" "$INSTDIR\ll_icon.ico"

  CreateShortCut "$SMPROGRAMS\${MUI_PRODUCT}\Uninstall Loglet Lab 2.lnk" "$INSTDIR\Uninstall.exe"


SectionEnd

;Display the Finish header
;Insert this macro after the sections if you are not using a finish page
!insertmacro MUI_SECTIONS_FINISHHEADER

;--------------------------------
;Descriptions

!insertmacro MUI_FUNCTIONS_DESCRIPTION_BEGIN
  !insertmacro MUI_DESCRIPTION_TEXT ${SecCopyUI} $(DESC_SecCopyUI)
!insertmacro MUI_FUNCTIONS_DESCRIPTION_END
 
;--------------------------------
;Uninstaller Section

Section "Uninstall"

  ;ADD YOUR OWN STUFF HERE!
  Delete "$INSTDIR\LogletLab.Properties"
  Delete "$INSTDIR\LogletLabClasses.jar"
  Delete "$INSTDIR\jdom.jar"
  Delete "$INSTDIR\jxl.jar"
  Delete "$INSTDIR\License.txt"
  Delete "$INSTDIR\readme.txt"
  Delete "$INSTDIR\ll_icon.ico"
  Delete "$INSTDIR\ll_icon16.png"
  Delete "$INSTDIR\ll_icon.ico"
  Delete "$INSTDIR\llsplash.png"

  Delete "$INSTDIR\Loglet Lab 2.lnk"
  Delete "$DESKTOP\Loglet Lab 2.lnk"

  Delete "$SMPROGRAMS\${MUI_PRODUCT}\Loglet Lab 2.lnk"
  Delete "$SMPROGRAMS\${MUI_PRODUCT}\Uninstall Loglet Lab 2.lnk"
  RMDir "$SMPROGRAMS\${MUI_PRODUCT}"

  Delete "$INSTDIR\modern.exe"
  Delete "$INSTDIR\Uninstall.exe"

  RMDir "$INSTDIR"

  DeleteRegKey /ifempty HKCU "Software\${MUI_PRODUCT}"
  
  ;Display the Finish header
  !insertmacro MUI_UNFINISHHEADER

SectionEnd